﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TSF.InteropTypes;

namespace SoftKeyboardDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        protected override void OnClosed(EventArgs e)
        {
            base.OnClosed(e);

            keyboard.Release();
        }

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);

            //var test = InputLanguageManager.Current.AvailableInputLanguages;
            //textbox1.Focus();
        }

        [DllImport("imm32.dll")]
        public static extern IntPtr ImmGetContext(IntPtr hWnd);

        [DllImport("imm32.dll")]
        public static extern bool ImmGetConversionStatus(IntPtr hIMC,
            ref int conversion, ref int sentence);

        [DllImport("imm32.dll")]
        public static extern bool ImmSetConversionStatus(IntPtr hIMC, int conversion, int sentence);

        [DllImport("imm32.dll")]
        private static extern bool ImmSetOpenStatus(IntPtr himc, bool b);

        [DllImport("Msctf.dll")]
        private static extern HRESULT SetInputScope(IntPtr hwnd, uint inputscope);

        private void button_Click(object sender, RoutedEventArgs e)
        {
            var handle = new WindowInteropHelper(this).Handle;
            var hImc = ImmGetContext(handle);
            var conversion = 0;
            var sentence = 0;
            //ImmGetConversionStatus(hImc, ref conversion, ref sentence);
            //ImmSetOpenStatus(hImc, false);
            ImmSetConversionStatus(hImc, 0, 0);
            //ImmGetConversionStatus(hImc, ref conversion, ref sentence);

            //var result = SetInputScope(handle, IS_ONECHAR);
        }

        private void button_Copy_Click(object sender, RoutedEventArgs e)
        {
            var handle = new WindowInteropHelper(this).Handle;
            var hImc = ImmGetContext(handle);
            //var conversion = 0;
            //var sentence = 0;
            //ImmGetConversionStatus(hImc, ref conversion, ref sentence);
            //ImmSetOpenStatus(hImc, false);
            ImmSetConversionStatus(hImc, 1, 0);
        }
    }
}
